package com.jisco.dynamicweight.dynamicbasematerial.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasematerial.model.DynamicBaseMaterial;
import com.jisco.dynamicweight.dynamicbasematerial.service.IDynamicBaseMaterialService;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.baseinfo.meterbasecalibrarelation.model.MeterBaseCalibraRelation;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.*;

/**
 * DynamicBaseMaterial RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-06 10:10
 * 类描述
 * 修订历史：
 * 日期：2022-01-06
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseMaterial RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/dynamicbasematerials")
public class DynamicBaseMaterialController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseMaterialService dynamicBaseMaterialService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasematerial:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseMaterial> list = dynamicBaseMaterialService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasematerial:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseMaterial> list = dynamicBaseMaterialService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据DynamicBaseMaterial对象创建")
    @ApiImplicitParam(name = "dynamicBaseMaterial", value = "详细实体dynamicBaseMaterial", required = true, dataType = "DynamicBaseMaterial")
    //@RequiresPermissions("dynamicbasematerial:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseMaterial model){
        Assert.isTrue(StringUtils.isNotBlank(model.getMaterialName()), "请输入数采物料名称!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getMaterialCode()), "请输皮卡物料编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getPikaMaterialName()), "请输入皮卡系统物料名称!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
//        Assert.isTrue(Objects.nonNull(model.getIsReturnedDust()), "请选择是否返粉!");
//        Assert.isTrue(Objects.nonNull(model.getIsCoke()), "请选择是否是焦炭!");
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseMaterial dynamicBaseMaterial = dynamicBaseMaterialService.add(model);
        return success(dynamicBaseMaterial);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasematerial:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        DynamicBaseMaterial dynamicBaseMaterial = dynamicBaseMaterialService.getById(id);
        return success(dynamicBaseMaterial);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的dynamicBaseMaterial信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "dynamicBaseMaterial", value = "详细实体dynamicBaseMaterial", required = true, dataType = "DynamicBaseMaterial")
    })
    //@RequiresPermissions("dynamicbasematerial:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseMaterial model){
        Assert.isTrue(StringUtils.isNotBlank(model.getMaterialName()), "请输入数采物料名称!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getMaterialCode()), "请输皮卡物料编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getPikaMaterialName()), "请输入皮卡系统物料名称!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
//        Assert.isTrue(Objects.nonNull(model.getIsReturnedDust()), "请选择是否返粉!");
//        Assert.isTrue(Objects.nonNull(model.getIsCoke()), "请选择是否是焦炭!");
        model.setId(id);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseMaterial dynamicBaseMaterial = dynamicBaseMaterialService.modify(model);
        return success(dynamicBaseMaterial);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasematerial:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  dynamicBaseMaterialService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseMaterial> list = dynamicBaseMaterialService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseMaterial.class, "动态秤物料信息");
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseCalibraRelation> list = dynamicBaseMaterialService.queryall(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "启用", notes = "启用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/enable/{id}")
    public RESTfulResult enable(@PathVariable String id) {
        boolean flag = dynamicBaseMaterialService.enable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }

    @ApiOperation(value = "禁用", notes = "禁用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/disable/{id}")
    public RESTfulResult disable(@PathVariable String id) {
        boolean flag = dynamicBaseMaterialService.disable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }
}
